/*
 * DictionaryForm.java
 *
 * Created on 2005/11/24, 9:33
 */

package collection;

import dictionary.Dictionary;
import dictionary.MapDictionary;
import java.util.Map;

/**
 *
 * @author  kishida
 */
public class DictionaryForm extends javax.swing.JFrame {
    protected Dictionary dic;
    
    /** ̏ */
    protected Dictionary getDictionary(){
        return new MapDictionary();
    }
    
    /** Creates new form DictionaryForm */
    public DictionaryForm() {
        dic = getDictionary();
        initComponents();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" ꂽR[h">//GEN-BEGIN:initComponents
    private void initComponents() {
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        txtEnglish = new javax.swing.JTextField();
        txtJapanese = new javax.swing.JTextField();
        txtSearch = new javax.swing.JTextField();
        btnRegist = new javax.swing.JButton();
        btnSearch = new javax.swing.JButton();
        btnList = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        taOutput = new javax.swing.JTextArea();

        getContentPane().setLayout(null);

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        jLabel1.setText("\u82f1\u8a9e");
        getContentPane().add(jLabel1);
        jLabel1.setBounds(10, 10, 30, 13);

        jLabel2.setText("\u65e5\u672c\u8a9e");
        getContentPane().add(jLabel2);
        jLabel2.setBounds(170, 10, 50, 13);

        jLabel3.setText("\u691c\u7d22\u8a9e");
        getContentPane().add(jLabel3);
        jLabel3.setBounds(10, 40, 40, 13);

        getContentPane().add(txtEnglish);
        txtEnglish.setBounds(60, 10, 100, 18);

        getContentPane().add(txtJapanese);
        txtJapanese.setBounds(210, 10, 100, 18);

        getContentPane().add(txtSearch);
        txtSearch.setBounds(60, 40, 100, 18);

        btnRegist.setText("\u767b\u9332");
        btnRegist.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnRegistActionPerformed(evt);
            }
        });

        getContentPane().add(btnRegist);
        btnRegist.setBounds(320, 10, 70, 21);

        btnSearch.setText("\u691c\u7d22");
        btnSearch.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnSearchActionPerformed(evt);
            }
        });

        getContentPane().add(btnSearch);
        btnSearch.setBounds(170, 40, 70, 21);

        btnList.setText("\u4e00\u89a7");
        btnList.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnListActionPerformed(evt);
            }
        });

        getContentPane().add(btnList);
        btnList.setBounds(320, 40, 70, 21);

        jScrollPane1.setViewportView(taOutput);

        getContentPane().add(jScrollPane1);
        jScrollPane1.setBounds(10, 70, 380, 190);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-400)/2, (screenSize.height-300)/2, 400, 300);
    }
    // </editor-fold>//GEN-END:initComponents

    /** eLXgGAɑ΂ďto͂s */
    void formatOutput(String format, Object... args){
        String str = String.format(format + "\n", args);
        taOutput.append(str);
    }    
    
    /** ꗗ{^̏ */
    private void btnListActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnListActionPerformed
        taOutput.append("--- ꗗ ---\n");
        Map<String, String> wordList = dic.getList();
        for(Map.Entry<String, String> me : wordList.entrySet()){
            formatOutput("%s̓{%s", me.getKey(), me.getValue());
        }
        taOutput.append("---\n");
    }//GEN-LAST:event_btnListActionPerformed

    /** {^̏ */
    private void btnSearchActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnSearchActionPerformed
        String english = txtSearch.getText();
        String japanese = dic.search(english);
        if(japanese != null){
            formatOutput("%s̓{%sł", english, japanese);
        } else {
            formatOutput("%s̓{݂͂܂ł", english);
        }
    }//GEN-LAST:event_btnSearchActionPerformed

    /** o^{^̏ */
    private void btnRegistActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnRegistActionPerformed
        String english = txtEnglish.getText();
        String japanese = txtJapanese.getText();
        dic.regist(english, japanese);
        formatOutput("%s/%so^܂", english, japanese);
    }//GEN-LAST:event_btnRegistActionPerformed
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new DictionaryForm().setVisible(true);
            }
        });
    }
    
    // ϐ錾 - ҏWs//GEN-BEGIN:variables
    private javax.swing.JButton btnList;
    private javax.swing.JButton btnRegist;
    private javax.swing.JButton btnSearch;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextArea taOutput;
    private javax.swing.JTextField txtEnglish;
    private javax.swing.JTextField txtJapanese;
    private javax.swing.JTextField txtSearch;
    // ϐ錾̏I//GEN-END:variables
    
}
