/*
 * PrintSample.java
 *
 * Created on 2005/11/22, 8:08
 */

package io;

import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.print.PageFormat;
import java.awt.print.Printable;
import javax.print.Doc;
import javax.print.DocFlavor;
import javax.print.DocPrintJob;
import javax.print.PrintException;
import javax.print.PrintService;
import javax.print.PrintServiceLookup;
import javax.print.ServiceUI;
import javax.print.SimpleDoc;
import javax.print.attribute.HashPrintRequestAttributeSet;
import javax.print.attribute.PrintRequestAttributeSet;
import javax.print.attribute.standard.Chromaticity;
import javax.print.attribute.standard.JobName;
import javax.print.attribute.standard.MediaSizeName;
import javax.print.attribute.standard.OrientationRequested;
import javax.swing.JComponent;

/**
 *
 * @author  kishida
 */
public class PrintSample extends javax.swing.JFrame {
    /** vr[̕\ */
    class Preview extends JComponent{
        @Override
        public void paintComponent(Graphics g){
            g.fillRect(10, 30, 170, 30);
            g.fillRect(10, 65, 170, 30);
            g.fillRect(10, 100, 170, 30);
            g.setFont(new Font("Serif", Font.PLAIN, 20));
            g.drawString("Easy Sample:̕`", 135, 180);
            g.setFont(new Font("SansSerif", Font.ITALIC, 20));
            g.drawString("Easy Sample:̕`", 135, 210);
            g.setColor(Color.CYAN);
            g.fillOval(50, 45, 70, 70);
        }
    }
    Preview preview = new Preview();
    
    /** f[^ */
    class SamplePrint implements Printable{
        public int print(Graphics g, PageFormat pf, int pageIndex){
            if(pageIndex > 0) return Printable.NO_SUCH_PAGE;
            double x = pf.getImageableX();
            double y = pf.getImageableY();
            ((Graphics2D)g).translate(x, y);
            preview.paintComponent(g);
            return Printable.PAGE_EXISTS;
        }
    }    
    
    /** Creates new form PrintSample */
    public PrintSample() {
        initComponents();
        getContentPane().add(preview);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" ꂽR[h">//GEN-BEGIN:initComponents
    private void initComponents() {
        jPanel1 = new javax.swing.JPanel();
        btnPrint = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        btnPrint.setText("\u5370\u5237");
        btnPrint.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnPrintActionPerformed(evt);
            }
        });

        jPanel1.add(btnPrint);

        getContentPane().add(jPanel1, java.awt.BorderLayout.NORTH);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-400)/2, (screenSize.height-300)/2, 400, 300);
    }
    // </editor-fold>//GEN-END:initComponents

    private void btnPrintActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnPrintActionPerformed
        //v^ꗗ̎擾
        PrintService[] services = 
                PrintServiceLookup.lookupPrintServices(null, null);
        if(services.length == 0){
            //v^Ȃ
            return;
        }
        //݂̃v^̎擾
        PrintService defaultService = 
                PrintServiceLookup.lookupDefaultPrintService();
        //f[^̎ނw
        DocFlavor flavor = DocFlavor.SERVICE_FORMATTED.PRINTABLE;
        //̎w
        PrintRequestAttributeSet pras = 
                new HashPrintRequestAttributeSet();
        pras.add(new JobName("eXg", null));
        pras.add(MediaSizeName.ISO_A4);
        pras.add(Chromaticity.MONOCHROME);
        pras.add(OrientationRequested.LANDSCAPE);
        //_CAO̕\
        PrintService ps = ServiceUI.printDialog(null, 50, 50, 
            services, defaultService, flavor, pras);
        if(ps == null){
            //LZꂽ
            return;
        }
        //s
        DocPrintJob job = ps.createPrintJob();
        Printable print = new SamplePrint();
        Doc doc = new SimpleDoc(print, flavor, null);
        try{
            job.print(doc, pras);
        } catch (PrintException e){
            e.printStackTrace();
        }
    }//GEN-LAST:event_btnPrintActionPerformed
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new PrintSample().setVisible(true);
            }
        });
    }
    
    // ϐ錾 - ҏWs//GEN-BEGIN:variables
    private javax.swing.JButton btnPrint;
    private javax.swing.JPanel jPanel1;
    // ϐ錾̏I//GEN-END:variables
    
}
